import { QRL, QwikIntrinsicElements } from '@builder.io/qwik';
export declare const DEFAULT_RESOLUTIONS: number[];
type ImageAttributes = QwikIntrinsicElements['img'];
/**
 * @alpha
 */
export type ImageState = {
    resolutions?: number[];
    imageTransformer$?: QRL<(params: ImageTransformerProps) => string>;
};
/**
 * @alpha
 */
export type ImageTransformerProps = {
    src: string;
    width: number;
    height: number | undefined;
};
/**
 * @alpha
 */
export interface ImageProps extends ImageAttributes {
    placeholder?: string;
    style?: Record<string, string | number>;
    aspectRatio?: number;
    layout: 'fixed' | 'constrained' | 'fullWidth';
    objectFit?: 'contain' | 'cover' | 'fill' | 'none' | 'scale-down' | 'inherit' | 'initial';
}
export declare const ImageContext: import("@builder.io/qwik").ContextId<ImageState>;
/**
 * @alpha
 */
export declare const useImageProvider: (state: ImageState) => void;
export declare const isValid: (value?: string | number) => string | number | boolean;
export declare const getStyles: ({ placeholder, width, height, aspectRatio, objectFit, layout, }: Pick<ImageProps, 'placeholder' | 'width' | 'height' | 'aspectRatio' | 'objectFit' | 'layout'>) => Record<string, string | undefined>;
export declare const getSizes: ({ width, layout, }: Pick<ImageProps, 'width' | 'layout'>) => string | undefined;
export declare const getSrcSet: ({ src, width, height, aspectRatio, layout, resolutions, imageTransformer$, }: Pick<ImageProps, 'src' | 'width' | 'height' | 'aspectRatio' | 'layout'> & ImageState) => Promise<string>;
export declare const getBreakpoints: ({ width: widthAttribute, layout, resolutions, }: Pick<ImageProps, 'width' | 'layout'> & Pick<ImageState, 'resolutions'>) => number[];
/**
 * @alpha
 */
export declare const Image: import("@builder.io/qwik").Component<ImageProps>;
export {};
